"""Raw representations of every data type in the AWS CloudTrail service.

See Also:
    `AWS developer guide for CloudTrail
    <https://docs.aws.amazon.com/awscloudtrail/latest/userguide/cloudtrail-user-guide.html>`_

This file is automatically generated, and should not be directly edited.
"""

from attr import attrib
from attr import attrs

from ..core import ATTRSCONFIG
from ..core import Resource
from ..core import ResourceProperties
from ..core import create_object_converter

__all__ = ["Trail", "TrailProperties"]


@attrs(**ATTRSCONFIG)
class TrailProperties(ResourceProperties):
    CloudWatchLogsLogGroupArn = attrib(default=None)
    CloudWatchLogsRoleArn = attrib(default=None)
    EnableLogFileValidation = attrib(default=None)
    EventSelectors = attrib(default=None)
    IncludeGlobalServiceEvents = attrib(default=None)
    IsLogging = attrib(default=None)
    IsMultiRegionTrail = attrib(default=None)
    KMSKeyId = attrib(default=None)
    S3BucketName = attrib(default=None)
    S3KeyPrefix = attrib(default=None)
    SnsTopicName = attrib(default=None)
    Tags = attrib(default=None)
    TrailName = attrib(default=None)


@attrs(**ATTRSCONFIG)
class Trail(Resource):
    """A Trail for CloudTrail.

    See Also:
        `AWS Cloud Formation documentation for Trail
        <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-cloudtrail-trail.html>`_
    """

    RESOURCE_TYPE = "AWS::CloudTrail::Trail"

    Properties: TrailProperties = attrib(
        factory=TrailProperties, converter=create_object_converter(TrailProperties)
    )
