"""Raw representations of every data type in the AWS DirectoryService service.

See Also:
    `AWS developer guide for DirectoryService
    <https://docs.aws.amazon.com/directoryservice/latest/admin-guide/index.html>`_

This file is automatically generated, and should not be directly edited.
"""

from attr import attrib
from attr import attrs

from ..core import ATTRSCONFIG
from ..core import Resource
from ..core import ResourceProperties
from ..core import create_object_converter

__all__ = ["MicrosoftAD", "MicrosoftADProperties", "SimpleAD", "SimpleADProperties"]


@attrs(**ATTRSCONFIG)
class MicrosoftADProperties(ResourceProperties):
    CreateAlias = attrib(default=None)
    Edition = attrib(default=None)
    EnableSso = attrib(default=None)
    Name = attrib(default=None)
    Password = attrib(default=None)
    ShortName = attrib(default=None)
    VpcSettings = attrib(default=None)


@attrs(**ATTRSCONFIG)
class MicrosoftAD(Resource):
    """A Microsoft Ad for DirectoryService.

    See Also:
        `AWS Cloud Formation documentation for MicrosoftAD
        <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-directoryservice-microsoftad.html>`_
    """

    RESOURCE_TYPE = "AWS::DirectoryService::MicrosoftAD"

    Properties: MicrosoftADProperties = attrib(
        factory=MicrosoftADProperties,
        converter=create_object_converter(MicrosoftADProperties),
    )


@attrs(**ATTRSCONFIG)
class SimpleADProperties(ResourceProperties):
    CreateAlias = attrib(default=None)
    Description = attrib(default=None)
    EnableSso = attrib(default=None)
    Name = attrib(default=None)
    Password = attrib(default=None)
    ShortName = attrib(default=None)
    Size = attrib(default=None)
    VpcSettings = attrib(default=None)


@attrs(**ATTRSCONFIG)
class SimpleAD(Resource):
    """A Simple Ad for DirectoryService.

    See Also:
        `AWS Cloud Formation documentation for SimpleAD
        <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-directoryservice-simplead.html>`_
    """

    RESOURCE_TYPE = "AWS::DirectoryService::SimpleAD"

    Properties: SimpleADProperties = attrib(
        factory=SimpleADProperties,
        converter=create_object_converter(SimpleADProperties),
    )
