"""Raw representations of every data type in the AWS DynamoDB service.

See Also:
    `AWS developer guide for DynamoDB
    <https://docs.aws.amazon.com/amazondynamodb/latest/developerguide/index.html>`_

This file is automatically generated, and should not be directly edited.
"""

from attr import attrib
from attr import attrs

from ..core import ATTRSCONFIG
from ..core import Resource
from ..core import ResourceProperties
from ..core import create_object_converter

__all__ = ["Table", "TableProperties"]


@attrs(**ATTRSCONFIG)
class TableProperties(ResourceProperties):
    AttributeDefinitions = attrib(default=None)
    BillingMode = attrib(default=None)
    GlobalSecondaryIndexes = attrib(default=None)
    KeySchema = attrib(default=None)
    LocalSecondaryIndexes = attrib(default=None)
    PointInTimeRecoverySpecification = attrib(default=None)
    ProvisionedThroughput = attrib(default=None)
    SSESpecification = attrib(default=None)
    StreamSpecification = attrib(default=None)
    TableName = attrib(default=None)
    Tags = attrib(default=None)
    TimeToLiveSpecification = attrib(default=None)


@attrs(**ATTRSCONFIG)
class Table(Resource):
    """A Table for DynamoDB.

    See Also:
        `AWS Cloud Formation documentation for Table
        <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-dynamodb-table.html>`_
    """

    RESOURCE_TYPE = "AWS::DynamoDB::Table"

    Properties: TableProperties = attrib(
        factory=TableProperties, converter=create_object_converter(TableProperties)
    )
